'use strict';

const _ = require('lodash');
const Promise = require('bluebird');
const AWS = require('aws-sdk');

const LambdaInvokee = require('./lambda/invokee');
const LambdaInvoker = require('./lambda/invoker');


// This establishes a private namespace.
const namespace = new WeakMap();
function p(object) {
  if (!namespace.has(object)) namespace.set(object, {});
  return namespace.get(object);
}



/**
 *
 */
module.exports = class JobRunner {
  constructor(config) {
    config = config || {};

    p(this).log = {
      notice: _.get(config, 'log.notice', console.log),
      error: _.get(config, 'log.error', console.log)
    };

    p(this).directory = config.directory || 'jobs';

    p(this).jobName = config.jobName;
    if (!p(this).jobName) throw new Error('jobName must be provided to JobRunner.');

    if (!config.jobId) {
      p(this).log.notice(`
        Warning: No jobId provided to JobRunner.
        Please provide if attempting to continue a previous job, or if you'd like
        to use your own format. Default jobId is current timestamp.
      `);
    }
    p(this).jobId = String(config.jobId || Date.now());

    p(this).fullDir = _.compact([
      p(this).directory,
      p(this).jobName,
      p(this).jobId
    ]).join('/');

    console.log('FULL DIR', p(this).fullDir);

    
    // Initialize Invoker.
    // TODO This should create a lambda function but for now
    // it has to be provided.
    // p(this).invoker = new LambdaInvoker(config.lambda);

    // Initialize Store.

  }
}

